% ================================
% ECE 441 -- Control System Design
% Exercise Sheet 2
% ================================
% Problem 5
% Comparison
K = 1;
r = 1;
d = 0;
sim('ECE441_Ex2_P5_solution_simulink')
figure;
plot(time,y,'r')
hold on;
grid on;
K = 14;
sim('ECE441_Ex2_P5_solution_simulink')
plot(time,y,'b')
xlabel('time')
ylabel('output')
legend('K = 1','K = 14')
% =======================
K = 1;
r = 0;
d = 1;
sim('ECE441_Ex2_P5_solution_simulink')
figure;
plot(time,y,'r')
hold on;
grid on;
K = 14;
sim('ECE441_Ex2_P5_solution_simulink')
plot(time,y,'b')
legend('K = 1','K = 14')

% ================================
% Problem 6
% ================================
% Parameters
La = 2E-3;
Ra = 10;
Ja = 3E-6;
cPhiF = .05;
% ================================
% Part b)
% ================================
r = 0;
u_ref = 1;
u = 1;
M_L = 0;
% Input step response
options = simset('MaxStep',0.0001);
sim('ECE441_Ex2_P6_solution_simulink',[0,.1],options);
figure;
plot(t,y1,'k');
grid;
xlabel('time [sec]')
ylabel('Angular velocity [rad/sec]')
% Disturbance step response
u_ref = 0;
u = 0; 
M_L = 1E-3;
sim('ECE441_Ex2_P6_solution_simulink',[0,.1],options);
figure;
plot(t,y1,'k');
grid;
xlabel('time [sec]')
ylabel('Angular velocity [rad/sec]')


% =======================================
% Part c)
% =======================================
u_ref = 1;
r = 20;
M_L = 0;
% Reference step response
options = simset('MaxStep',0.0001);
sim('ECE441_Ex2_P6_solution_simulink',[0,.02],options);
figure;
plot(t,y,'k');
grid;
xlabel('time [sec]')
ylabel('Angular velocity [rad/sec]')
% Disturbance rejection
u_ref = 0;
r = 0; 
M_L = 1E-3;
sim('ECE441_Ex2_P6_solution_simulink',[0,.02],options);
figure;
plot(t,y,'k');
grid;
xlabel('time [sec]')
ylabel('Angular velocity [rad/sec]')
